local mt = {}
mt.__index = mt

stuff = {}
stuff.r = 0
stuff.vy = 0

function mt:update (dt)
  if self.isDisabled then return end
  local new_r = stuff.r
  local vx = 0

  if love.keyboard.isDown("space") and --[[not self.was_jump_pressed_in_previous_frame and]] self.isGrounded == true then
    stuff.vy = self.JUMP_HEIGHT
    self.isGrounded = false
    if self.movingRight then
      flux.to(stuff, 0.7, {r = new_r + math.pi})
    else
      flux.to(stuff, 0.7, {r = new_r - math.pi})
    end
  end

  if love.keyboard.isDown("right") then
    vx = vx + self.speed * dt
    self.movingRight = true
  end

  if love.keyboard.isDown("left") then
    vx = vx - self.speed * dt
    self.movingRight = false
  end

  local goalX, goalY = self.x + vx, self.y + stuff.vy
  local actualX, actualY, cols, len = self.world:move(self, goalX, goalY)
  self.x, self.y = actualX, actualY

  stuff.vy = math.min(stuff.vy + self.GRAVITY * dt, 12)
  if self.isGrounded == true then stuff.vy = 2  end

  self.isGrounded = false
  for i, v in ipairs(cols) do
    if cols[i].normal.y == -1 then
      self.isGrounded = true
    end
  end
  self.was_jump_pressed_in_previous_frame = love.keyboard.isDown('up')

  if self.isGrounded then stuff.r = 0 end
end

function mt:draw ()
  if self.isDisabled then return end
  --love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
  love.graphics.draw(self.img, self.x + 6, self.y + 6, stuff.r, 1, 1, 6, 6)
end

return {
  new = function (x, y, world)
    return setmetatable({
      x = x,
      y = y,
      world = world,
      w = 12,
      h = 12,
      r = 0,
      sx = 2,
      sy = 2,
      speed = 122,
      JUMP_HEIGHT = -7.5,
      GRAVITY = 35,
      movingRight = true,
      isGrounded = false,
      isPlayer = true,
      img = love.graphics.newImage("img/player.png"),
    }, mt)
  end
}
