local mt = {}
mt.__index = mt

local closed_img = love.graphics.newImage('img/closeddoor.png')
local open_img = love.graphics.newImage('img/opendoor.png')
local img = closed_img

function mt:update(dt)
end

function mt:draw()
  if self.is_closed == false then
    img = love.graphics.draw(open_img, self.x, self.y)
  else
    img = love.graphics.draw(closed_img, self.x, self.y)
  end
end

return {
  new = function(x, y)
    return setmetatable({
      x = x,
      y = y,
      w = img:getWidth(),
      h = img:getHeight(),
      is_closed = true,
      is_door = true
    }, mt)
  end
}
