local mt = {}
mt.__index = mt

if not const.get_out then
  --Doors
  door21 = Door.new(424, 128) bump_world2:add(door21, door21.x, door21.y, door21.w, door21.h) laser_world2:add(door21)
  door22 = Door.new(552, 176) bump_world2:add(door22, door22.x, door22.y, door22.w, door22.h) laser_world2:add(door22)
  door23 = Door.new(216, 176) bump_world2:add(door23, door23.x, door23.y, door23.w, door23.h) laser_world2:add(door23)
  door24 = Door.new(72, 384) bump_world2:add(door24, door24.x, door24.y, door24.w, door24.h) laser_world2:add(door24)
  door25 = Door.new(728, 400) bump_world2:add(door25, door25.x, door25.y, door25.w, door25.h) laser_world2:add(door25)
  door26 = Door.new(8, 32) bump_world2:add(door26, door26.x, door26.y, door26.w, door26.h) laser_world2:add(door26)

  --Keys
  key21 = Key.new(243, 38) laser_world2:add(key21)
  key22 = Key.new(691, 38) laser_world2:add(key22)
  key23 = Key.new(708, 262) laser_world2:add(key23)
  key24 = Key.new(578, 310) laser_world2:add(key24)
  key25 = Key.new(52, 437) laser_world2:add(key25)
end

----------------------------
local function collectKey(a, b)
  if laser_world2:check_pos(player_lvl2, "is_key") and b.is_closed == true then
    a.is_collected = true
    b.is_closed = false
    bump_world2:remove(b)
    a.x, a.y = -20, -20
  end
end

local function backToLevel1()
  for i, item in ipairs(laser_world2.items) do
    if item.is_door then
      if item.is_closed and item ~= door25 then
        item.is_closed = false
        bump_world2:remove(item)
      end
    end
  end
end

function mt:update(dt)
  if const.get_out then
    backToLevel1()
    return
  end
  collectKey(key21, door21)
  collectKey(key22, door22)
  collectKey(key23, door23)
  collectKey(key24, door24)
  collectKey(key25, door25)
end

function mt:draw()
  if const.get_out then
    door25:draw()
  end
end


return {
  new = function()
    return setmetatable({}, mt)
  end
}
