local mt = {}
mt.__index = mt

if not const.get_out then
  --Doors
  door31 = Door.new(344, 224) bump_world3:add(door31, door31.x, door31.y, door31.w, door31.h) laser_world3:add(door31)
  door32 = Door.new(440, 224) bump_world3:add(door32, door32.x, door32.y, door32.w, door32.h) laser_world3:add(door32)
  door33 = Door.new(344, 576) bump_world3:add(door33, door33.x, door33.y, door33.w, door33.h) laser_world3:add(door33)
  door34 = Door.new(656, 448) bump_world3:add(door34, door34.x, door34.y, door34.w, door34.h) laser_world3:add(door34)
  door35 = Door.new(6, 32) bump_world3:add(door35, door35.x, door35.y, door35.w, door35.h) laser_world3:add(door35)

  key31 = Key.new(164, 166) laser_world3:add(key31)
  key32 = Key.new(243.5, 464) laser_world3:add(key32)
  key33 = Key.new(692, 592) laser_world3:add(key33)
end
----------------------------
artifact = Artifact.new()
----------------------------
local function collectKey(a, b)
  if laser_world3:check_pos(player_lvl3, "is_key") and b.is_closed == true then
    a.is_collected = true
    b.is_closed = false
    bump_world3:remove(b)
    if b == door31 then
      bump_world3:remove(door32)
      door32.is_closed = false
    end
    a.x, a.y = -20, -20
  end
end
----------------------------
function artifactAcquired ()
  if player_lvl3.x + player_lvl3.w > artifact.x and
  player_lvl3.x < artifact.x + artifact.w and
  player_lvl3.y + player_lvl3.w > artifact.y and
  player_lvl3.y < artifact.y + artifact.h then
    lvl3_complete = true
    const.get_out = true
    --spawn_x_lvl3, spawn_y_lvl3 = artifact.x-6, artifact.y
    spawn_x_lvl3, spawn_y_lvl3 = 32, 18
    run.start = true
    if door35.is_closed == true then
      bump_world3:remove(door35)
      door35.is_closed = false
    end
  end
end
----------------------------
local function backToLevel2()
  for i, item in ipairs(laser_world3.items) do
    if item.is_door then
      if item.is_closed then
        item.is_closed = false
        bump_world3:remove(item)
      end
    end
  end
end

function mt:update(dt)
  if const.get_out then
    backToLevel2()
    return
  end
  door31:update(dt)
  door32:update(dt)
  door33:update(dt)
  door34:update(dt)
  door35:update(dt)
  artifact:update(dt)
  collectKey(key31, door31)
  collectKey(key32, door33)
  collectKey(key33, door34)
end

function mt:draw()
  artifact:draw()
end

return {
  new = function()
    return setmetatable({}, mt)
  end
}
