local mt = {}
mt.__index = mt

local already_playing = true
function mt:update(dt)
  if self.start and self.paused == false then
    --milliseconds decrement
    local last_ms = self.ms
    if self.ms > 00 then
      self.ms = self.ms - 1
    end
    --minutes decrement and seconds reset
    if self.s == 00  then
      if self.m > 0 then
        self.m = self.m - 1
        self.s = 59
      end
    end
    --seconds decrement
    if self.ms == 00 and self.ms ~= last_ms then
      self.s = self.s - 1
    end
    --milliseconds reset
    if self.ms == 0 and self.s > 0 then
      self.ms = 59
    end
    -- is timer done?
    if s == 0  and ms == 0 then self.is_done = true end
  end
  if self.m == 0 and self.s == 0 and self.ms == 0 then
    self.timeout = true
    self.paused = true
  end

  if self.start == true and already_playing == true then
    beat:play()
    metronome:setLooping(true)
    metronome:play()
    already_playing = false
  end
end

function mt:draw()
  love.graphics.setFont(font)
  local try_again = "Press 'R' to try again"
  local time_o = "Time's out!"
  local getout = "Get out!"

  if self.timeout == true then
    love.graphics.setColor(0,0,0,0.35)
    love.graphics.rectangle('fill',0, 0, const.ww, const.wh)
    love.graphics.setColor(0,0,0)
    love.graphics.rectangle('fill', 0, const.wh/2 + 30, const.ww,50)
    love.graphics.setColor(1,1,1)
    love.graphics.print(time_o, const.ww/2  - font:getWidth(time_o) * 0.5, const.wh/2 + 30)
    love.graphics.setColor(0,0,0)
    love.graphics.rectangle('fill', 0, const.wh*0.75, const.ww,50)
    love.graphics.setColor(1,1,1)
    love.graphics.print(try_again, const.ww/2  - font:getWidth(try_again) * 0.5, const.wh*0.75)
  end

  if self.start then
    love.graphics.setColor(1,1,1)
    --minutes
    love.graphics.print("0", self.x + 10, self.y)
    love.graphics.print(self.m, self.x + 35, self.y)

    love.graphics.print(":", self.x + 60, self.y)

    --seconds
    if string.len(self.s) ==1 then
      love.graphics.print("0", self.x + 70, self.y)
      love.graphics.print(self.s, self.x + 95, self.y)
    else
      love.graphics.print(self.s, self.x + 70, self.y)
    end

    love.graphics.print(":", self.x + 120.5, self.y)

    --milli-seconds
    if string.len(self.ms) ==1 then
      love.graphics.print("0", self.x + 132, self.y)
      love.graphics.print(self.ms, self.x + 159, self.y)
    else
      love.graphics.print(self.ms, self.x + 132, self.y)
    end
  end
end



return{
  new = function ()
    return setmetatable({
      -- x = const.ww - 185 ,
      x = const.ww/2 - 80 ,
      y = const.wh/2 - 30,
      w = 185,
      h = 40,
      s = 0,
      ms = 0,
      m = 3,
      is_done = false,
      start = false,
      paused = false,
      timeout = false
    }, mt)
  end
}
