local mt = {}
mt.__index = mt



local ww = love.graphics.getWidth()
local wh = love.graphics.getHeight()

local bg1 = love.graphics.newImage('img/bg2.png')
local bg2 = love.graphics.newImage('img/bg2.png')

local bg_x1, bg_y1 = 0,0
local bg_x2, bg_y2 = 0, -wh

local img = love.graphics.newImage("img/logo.png")
thanks = love.graphics.newImage("img/ThanksButton.png")

local last, now = nil, nil


alpha = {i = 0, j = 0, k = 0}

function mt:update(dt)
  bg_y1 = bg_y1 + 1
  bg_y2 = bg_y2 + 1
  if bg_y1 > wh then
    bg_y1 = 0
  end
  if bg_y2 > 0 then
    bg_y2 = -wh
  end
  flux.update(dt)
end

function mt:draw()
  if self.is_enabled then
    love.graphics.setColor(0, 0, 0, alpha.i)
    love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)

    love.graphics.setColor(1,1,1,alpha.k)

    love.graphics.draw(bg1, bg_x1, bg_y1)
    love.graphics.draw(bg2, bg_x2, bg_y2)

    love.graphics.setColor(1,1,1,alpha.j)
    love.graphics.draw(img, ww/2 - img:getWidth()/2, wh * 0.35 - img:getHeight()/2)


    last = now
    local mx, my = love.mouse.getPosition()
    local bx, by = ww/2 - thanks:getWidth()/2, wh *  0.6
    local bw, bh = thanks:getWidth(), thanks:getHeight()

    local hot =  mx > bx and mx < bx + bw and
                my > by and my < by + bh

    if hot then
      thanks = love.graphics.newImage("img/ThanksButton2.png")
    else
      thanks = love.graphics.newImage("img/ThanksButton.png")
    end


    now = love.mouse.isDown(1)
    if now and not last and hot then
      love.event.quit()
    end


    love.graphics.draw(thanks, bx, by)
    flux.to(alpha, 1, {i = 0.5, j = 1})
    flux.to(alpha, 2, {k = 1}):ease('quadinout'):delay(1.5)
  else
    return
  end
end

return {
    new = function ()
return setmetatable( {
      x = 0,
      y = 0,
      w = ww,
      h = wh,
      is_enabled = false,
    }, mt)
  end
}
