local instructions = {}

local bg1 = love.graphics.newImage('img/bg2.png')
local bg2 = love.graphics.newImage('img/bg2.png')

local bg_x1, bg_y1 = 0,0
local bg_x2, bg_y2 = 0, -const.wh

local screen = {alpha = 1, fadein = true, fadeout = false, wait = 2}

function instructions:update(dt)
  if screen.fadein == true and screen.alpha > 0 then
    screen.alpha = screen.alpha - 0.01
  end
  if screen.alpha < 0 and screen.wait > 0 then
    screen.fadein = false
    screen.wait = screen.wait - 0.01
  end
  if screen.wait < 0 and screen.fadeout == false then
    if screen.alpha < 1 then
      screen.alpha = screen.alpha + 0.025
    end
    if screen.alpha > 1 then
      love.mouse.setPosition(-200, 700)
      Gamestate.switch(level1)
    end
  end

  bg_y1 = bg_y1 + 1
  bg_y2 = bg_y2 + 1
  if bg_y1 > const.wh then
    bg_y1 = 0
  end
  if bg_y2 > 0 then
    bg_y2 = -const.wh
  end
end

local title = "Controls:"
local titleW = font:getWidth(title)

local sentences = {
  {image = love.graphics.newImage("img/leftarrow.png"), text = "-  Move left"},
  {image = love.graphics.newImage("img/rightarrow.png"), text = "-  Move right"},
  {image = love.graphics.newImage("img/spacebarbutton.png"), text = "-  Space to jump"},
  {image = love.graphics.newImage("img/pausebutton.png"), text = "-  Pause"},
}

function instructions:draw()
  local lx = 30
  local ly = 90
  local inc = 1

  love.graphics.setColor(1,1,1,1)
  love.graphics.draw(bg1, bg_x1, bg_y1)
  love.graphics.draw(bg2, bg_x2, bg_y2)
  love.graphics.setColor(0,0,0,0.5)
  love.graphics.rectangle('fill', 0, 0, const.ww, const.wh)
  love.graphics.setFont(font)
  love.graphics.setColor(1,1,1,1)
  love.graphics.print(title, const.ww/2 - titleW * 0.5 , 20)
  love.graphics.line(0, 80,const.ww, 80 )

  for i, line in ipairs(sentences) do
    love.graphics.draw(line.image, lx, ly * inc, 0, 5, 5)
    love.graphics.print(line.text, lx + 250, ly * inc)
    inc = inc + 1
  end


  love.graphics.setColor(0,0,0,screen.alpha)
  love.graphics.rectangle('fill', 0,0,const.ww, const.wh)
end

return instructions
