local mt = {}
mt.__index = mt


laser_is_disabled = false

love.graphics.setDefaultFilter('nearest', 'nearest')

local img = love.graphics.newImage("img/particle.png")

function mt:update(dt)
  self.pSystem:setParticleLifetime(1,1.5)
  self.pSystem:setLinearAcceleration(-5,-5,5,5)
  self.pSystem:setSpeed(-2,2)
  self.pSystem:setSizes(0.09)
  self.pSystem:update(dt*10)
  self.pSystem:emit(16)

end


function mt:draw()
  --if const.get_out then return end
  if laser_is_disabled then return end
  love.graphics.setColor(const.laser_colour)
  love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
  if self.w > 2 then
    love.graphics.draw(self.pSystem, self.x + self.w, self.y + 0.5)
  elseif self.w < 0 then
    love.graphics.draw(self.pSystem, self.x + self.w, self.y-1)
  else
    love.graphics.draw(self.pSystem, self.x + 1, self.y + self.h)
  end
  love.graphics.setColor(1,1,1,1)
end

return {
  new = function (x, y, w, h)
    return setmetatable({
      x = x or 1,
      y = y or 1,
      w = w or 10,
      h = h or 10,
      pSystem = love.graphics.newParticleSystem(img, 16),
    }, mt)
  end
}
