teleportTimer1 = Timer.new()

laserTimer1 = Timer.new()
laserTimer1:every(const.laser_rate, function() laser_is_disabled = not laser_is_disabled end)

local mt = {}
mt.__index = mt

--Lasers
local laser_r1 = Laser.new(205, 103.5, 100, 1.25) laser_world1:add(laser_r1)
local laser_r2 = Laser.new(173, 343.5, 100, 1.25) laser_world1:add(laser_r2)
local laser_r3 = Laser.new(16, 487.5, 100, 1.25) laser_world1:add(laser_r3)
local laser_l1 = Laser.new(448, 200.5, -100, -1.25) laser_world1:add(laser_l1)
local laser_l2 = Laser.new(272, 296.5, -100, -1.25) laser_world1:add(laser_l2)
local laser_l3 = Laser.new(448, 392.5, -100, -1.25) laser_world1:add(laser_l3)
local laser_l4 = Laser.new(208, 488.5, -100, -1.25) laser_world1:add(laser_l4)
local laser_l5 = Laser.new(304, 488.5, -100, -1.25) laser_world1:add(laser_l5)
local laser_l6 = Laser.new(400, 488.5, -100, -1.25) laser_world1:add(laser_l6)
local laser_d1 = Laser.new(327.5, 126, 1.25, 100) laser_world1:add(laser_d1)
local laser_d2 = Laser.new(279.5, 126, 1.25, 100) laser_world1:add(laser_d2)
local laser_d3 = Laser.new(199.5, 126, 1.25, 100) laser_world1:add(laser_d3)
local laser_d4 = Laser.new(23.5, 126, 1.25, 100) laser_world1:add(laser_d4)
local laser_d5 = Laser.new(71.5, 173, 1.25, 100) laser_world1:add(laser_d5)
local laser_d6 = Laser.new(359.5, 224, 1.25, 100) laser_world1:add(laser_d6)
local laser_d7 = Laser.new(151.5, 316, 1.25, 100) laser_world1:add(laser_d7)
local laser_d8 = Laser.new(23.5, 316, 1.25, 100) laser_world1:add(laser_d8)

--Plates
local plate_r1 = Plate.new(253, 100) laser_world1:add(plate_r1)
local plate_r2 = Plate.new(269, 337) laser_world1:add(plate_r2)
local plate_r3 = Plate.new(109, 482) laser_world1:add(plate_r3)
local plate_l1 = Plate.new(353, 192) laser_world1:add(plate_l1)
local plate_l2 = Plate.new(177, 290) laser_world1:add(plate_l2)
local plate_l3 = Plate.new(370, 384) laser_world1:add(plate_l3)
local plate_l4 = Plate.new(130, 482) laser_world1:add(plate_l4)
local plate_l5 = Plate.new(225.5, 482) laser_world1:add(plate_l5)
local plate_l6 = Plate.new(321, 482) laser_world1:add(plate_l6)
local plate_d1 = Plate.new(320, 206) laser_world1:add(plate_d1)
local plate_d2 = Plate.new(273, 206) laser_world1:add(plate_d2)
local plate_d3 = Plate.new(192, 206) laser_world1:add(plate_d3)
local plate_d4 = Plate.new(20, 206) laser_world1:add(plate_d4)
local plate_d5 = Plate.new(64, 254) laser_world1:add(plate_d5)
local plate_d6 = Plate.new(352, 301) laser_world1:add(plate_d6)
local plate_d7 = Plate.new(144, 398) laser_world1:add(plate_d7)
local plate_d8 = Plate.new(16, 398) laser_world1:add(plate_d8)

local function teleportPlayer ()
  if not const.get_out then
    player_lvl1.isDisabled = true
    teleportTimer1:after(0.04, function()
      bump_world1:update(player_lvl1, spawn_x_lvl1, spawn_y_lvl1)
      player_lvl1.x = spawn_x_lvl1
      player_lvl1.y = spawn_y_lvl1
      player_lvl1.isDisabled = false
      stuff.vy = player_lvl1.JUMP_HEIGHT
      player_lvl1.isGrounded = false
      animation:resume()
    end)
  end
end

local function checkRight(a, b)
  a.w = 150
  if laser_world1:check_pos(a, "isPlate") then
    a.w = b.x - a.x
    if laser_world1:check_pos(a, "isPlayer") then
      a.w = player_lvl1.x - a.x
      teleportPlayer()
    end
  end
end

local function checkDown(a, b)
  a.h = 150
  if laser_world1:check_pos(a, "isPlate") then
    a.h = b.y - a.y
    if laser_world1:check_pos(a, "isPlayer") then
      a.h = player_lvl1.y - a.y
      teleportPlayer()
    end
  end
end

local function checkLeft(a, b)
  a.w = -150
  if laser_world1:check_neg(a, "isPlate") then
    a.w = (b.x + b.w) - a.x
    if laser_world1:check_neg(a, "isPlayer") then
      a.w = (player_lvl1.x + player_lvl1.w) - a.x
      teleportPlayer()
    end
  end
end

function mt:update(dt)
  teleportTimer1:update(dt)
  laserTimer1:update(dt)
  if laser_is_disabled then return end
  checkRight(laser_r1, plate_r1)
  checkRight(laser_r2, plate_r2)
  checkRight(laser_r3, plate_r3)
  checkDown(laser_d1, plate_d1)
  checkDown(laser_d2, plate_d2)
  checkDown(laser_d3, plate_d3)
  checkDown(laser_d4, plate_d4)
  checkDown(laser_d5, plate_d5)
  checkDown(laser_d6, plate_d6)
  checkDown(laser_d7, plate_d7)
  checkDown(laser_d8, plate_d8)
  checkLeft(laser_l1, plate_l1)
  checkLeft(laser_l2, plate_l2)
  checkLeft(laser_l3, plate_l3)
  checkLeft(laser_l4, plate_l4)
  checkLeft(laser_l5, plate_l5)
  checkLeft(laser_l6, plate_l6)
end

function mt:draw()
end

return {
  new = function ()
    return setmetatable({}, mt)
  end
}
