teleportTimer2 = Timer.new()

laserTimer2 = Timer.new()
laserTimer2:every(const.laser_rate, function() laser_is_disabled = not laser_is_disabled end)

local mt = {}
mt.__index = mt

--Lasers
local laser_r1 = Laser.new(52, 87, 100, 1.25) laser_world2:add(laser_r1)
local laser_r2 = Laser.new(354, 247, 100, 1.25) laser_world2:add(laser_r2)
local laser_r3 = Laser.new(307, 167, 100, 1.25) laser_world2:add(laser_r3)
local laser_r4 = Laser.new(18, 470.5, 100, 1.25) laser_world2:add(laser_r4)
local laser_l1 = Laser.new(349, 104.5, -100, -1.25) laser_world2:add(laser_l1)
local laser_l2 = Laser.new(716, 120.5, -100, -1.25) laser_world2:add(laser_l2)
local laser_l3 = Laser.new(636, 280.5, -100, -1.25) laser_world2:add(laser_l3)
local laser_l4 = Laser.new(684, 296.5, -100, -1.25) laser_world2:add(laser_l4)
local laser_l5 = Laser.new(203.5, 216.5, -100, -1.25) laser_world2:add(laser_l5)
local laser_d1 = Laser.new(231.5, 67, 1.25, 100) laser_world2:add(laser_d1)
local laser_d2 = Laser.new(263.5, 21, 1.25, 100) laser_world2:add(laser_d2)
local laser_d3 = Laser.new(103.5, 116, 1.25, 100) laser_world2:add(laser_d3)
local laser_d4 = Laser.new(103.5, 224, 1.25, 100) laser_world2:add(laser_d4)
local laser_d5 = Laser.new(567.5, 277, 1.25, 100) laser_world2:add(laser_d5)
local laser_d6 = Laser.new(23.5, 389, 1.25, 100) laser_world2:add(laser_d6)

--Plates
local plate_r1 = Plate.new(112, 80) laser_world2:add(plate_r1)
local plate_r2 = Plate.new(414, 240) laser_world2:add(plate_r2)
local plate_r3 = Plate.new(350, 161) laser_world2:add(plate_r3)
local plate_r4 = Plate.new(671, 464) laser_world2:add(plate_r4)
local plate_l1 = Plate.new(258, 98) laser_world2:add(plate_l1)
local plate_l2 = Plate.new(626, 114) laser_world2:add(plate_l2)
local plate_l3 = Plate.new(594, 275) laser_world2:add(plate_l3)
local plate_l4 = Plate.new(642, 290) laser_world2:add(plate_l4)
local plate_l5 = Plate.new(130, 210) laser_world2:add(plate_l5)
local plate_d1 = Plate.new(227, 143) laser_world2:add(plate_d1)
local plate_d2 = Plate.new(259, 79) laser_world2:add(plate_d2)
local plate_d3 = Plate.new(99, 222) laser_world2:add(plate_d3)
local plate_d4 = Plate.new(99, 318) laser_world2:add(plate_d4)
local plate_d5 = Plate.new(563, 318.5) laser_world2:add(plate_d5)
local plate_d6 = Plate.new(18.5, 447) laser_world2:add(plate_d6)

local function teleportPlayer ()
  if not const.get_out then
    player_lvl2.isDisabled = true
    teleportTimer2:after(0.04, function()
      bump_world2:update(player_lvl2, spawn_x_lvl2, spawn_y_lvl2)
      player_lvl2.x = spawn_x_lvl2
      player_lvl2.y = spawn_y_lvl2
      player_lvl2.isDisabled = false
      stuff.vy = player_lvl2.JUMP_HEIGHT/2
      player_lvl2.isGrounded = false
    end)
  end
end

local function checkRight(a, b)
  a.w = 680
  if laser_world2:check_pos(a, "isPlate") then
    a.w = b.x - a.x
    if laser_world2:check_pos(a, "isPlayer") then
      a.w = player_lvl2.x - a.x
      teleportPlayer()
    end
  end
end

local function checkDown(a, b)
  a.h = 350
  if laser_world2:check_pos(a, "isPlate") then
    a.h = b.y - a.y
    if laser_world2:check_pos(a, "isPlayer") then
      a.h = player_lvl2.y - a.y
      teleportPlayer()
    end
  end
end

local function checkLeft(a, b)
  a.w = -150
  if laser_world2:check_neg(a, "isPlate") then
    a.w = (b.x + b.w) - a.x
    if laser_world2:check_neg(a, "isPlayer") then
      a.w = (player_lvl2.x + player_lvl2.w) - a.x
      teleportPlayer()
    end
  end
end

function mt:update(dt)
  teleportTimer2:update(dt)
  laserTimer2:update(dt)
  if laser_is_disabled then return end
  checkLeft(laser_l1, plate_l1)
  checkLeft(laser_l2, plate_l2)
  checkLeft(laser_l3, plate_l3)
  checkLeft(laser_l4, plate_l4)
  checkLeft(laser_l5, plate_l5)
  checkRight(laser_r1, plate_r1)
  checkRight(laser_r2, plate_r2)
  checkRight(laser_r3, plate_r3)
  checkRight(laser_r4, plate_r4)
  checkDown(laser_d1, plate_d1)
  checkDown(laser_d2, plate_d2)
  checkDown(laser_d3, plate_d3)
  checkDown(laser_d4, plate_d4)
  checkDown(laser_d5, plate_d5)
  checkDown(laser_d6, plate_d6)
end

function mt:draw()
end

return {
  new = function ()
    return setmetatable({}, mt)
  end
}
