local game = {}

love.graphics.setDefaultFilter('nearest', 'nearest')

spawn_x_lvl2, spawn_y_lvl2 = 32, 18

local playerlvl2_has_teleported = false

screen2 = {alpha = 0, wait = 0,subtle_wait = 0}

laser_world2 = World.new()

--Instantiates lasers for level 1
local Lasers2 = require "lasers2"
local lasers2 = Lasers2.new()

--Map and collision stuff
bump_world2 = bump.newWorld(16)
local map = sti("map2/map2.lua", {"bump"})
map:bump_init(bump_world2)

--Player stuff
player_lvl2 = Player.new(spawn_x_lvl2, spawn_y_lvl2, bump_world2)
bump_world2:add(player_lvl2, player_lvl2.x, player_lvl2.y, player_lvl2.w, player_lvl2.h)
laser_world2:add(player_lvl2)

--Doors and keys
local Doors2 = require "doors2"
local doors2 = Doors2.new()

screen2.alpha = 1.3

function game:enter()
--Camera settings
  camera2 = Camera(player_lvl2.x, player_lvl2.y)
  camera2.scale = 4
  camera2:setDeadzone(const.ww/2, const.wh/4, 40,220)
  camera2:setFollowLerp(0.02)
  camera2:setBounds(-268,-174, 1270,870)

end

function game:update(dt)
  if const.get_out and playerlvl2_has_teleported == false then
    bump_world2:update(player_lvl2, 645, 379)
    playerlvl2_has_teleported = true
    player_lvl2.isDisabled = false
  end

  camera2:update(dt)
  if const.get_out then
    camera2:shake(5, 0.1, 20)
    camera2:fade(0.5, {0.25, 0, 0, math.random(0.1, 0.4)})
  end
  camera2:follow(player_lvl2.x, player_lvl2.y)

  if not run.timeout then
    for i, item in ipairs(laser_world2.items) do
      if not const.get_out then
        if item.update then
          item:update(dt)
        end
      elseif item.isPlayer then
        item:update(dt)
      end
    end
  end
  doors2:update(dt)
  lasers2:update(dt)
  if screen2.alpha > 0 and const.level2_complete == false then
    screen2.alpha = screen2.alpha - 0.025
  end
  level2Done ()
  level2Transition()
end

function game:keypressed(key)
  if key == 'p' and gameover.is_enabled == false and run.timeout == false then
    Gamestate.push(pause)
  end
  if key == 'return' and gameover.is_enabled == true then
    love.event.quit()
  end
  if key == 'r' and const.get_out == true then
    resetLevel2()
  end
end

function game:draw()
  love.graphics.setColor(1,1,1,1)
  camera2:attach()
  love.graphics.draw(const.bg)

  for i, item in ipairs(laser_world2.items) do
    if not const.get_out then
      item:draw()
    elseif item.isPlayer then
      item:draw()
    end
  end

  doors2:draw()

  map:draw()

  camera2:detach()
  camera2:draw()
  love.graphics.setColor(0,0,0,screen2.alpha)
  fade = love.graphics.rectangle('fill', 0, 0, const.ww+50, const.wh+100)
  run:draw()
end

function level2Done ()
  if player_lvl2.x > 730 and const.level3_complete == false then
    player_lvl2.isDisabled = true
    const.level2_complete = true
  end
  if player_lvl2.x < 0 and const.level3_complete==true then
    player_lvl2.isDisabled = true
    const.level2_complete = true
  end
end

function level2Transition()
  if const.level2_complete == true and const.level3_complete == false then
    screen2.subtle_wait = screen2.subtle_wait + 0.05
    if screen2.alpha < 1 and screen2.subtle_wait > 0.99 then
      screen2.alpha = screen2.alpha + 0.025
      breath:play()
    end

    if screen2.alpha > 0.99 then
      if screen2.wait < 1 then
      screen2.wait = screen2.wait + 0.01
      end
    end
    if screen2.wait > 0.99 then
      const.level2_complete = false
      Gamestate.switch(level3)
    end
  end
 if const.level2_complete == true and const.level3_complete == true then
    screen2.subtle_wait = screen2.subtle_wait + 0.05
    breath:play()
    if screen2.alpha < 1 and screen2.subtle_wait > 0.99 then
      screen2.alpha = screen2.alpha + 0.025
    end

    if screen2.alpha > 0.99 then
      if screen2.wait < 1 then
      screen2.wait = screen2.wait + 0.01
      end
    end
    if screen2.wait > 0.99 then
      screen1.alpha = 0
      Gamestate.switch(level1)
    end
  end
end

function resetLevel2 ()
  player_lvl3.x = 611
  player_lvl3.y = 129
  bump_world3:update(player_lvl3, 611, 129)
  run.m = 3
  run.paused = false
  run.timeout = false
  const.level_complete = false
  const.level3_complete = false
  player_lvl3.isDisabled = false
  screen3 = {alpha = 0, wait = 0,subtle_wait = 0}
  player_lvl2.x = 642
  player_lvl2.y = 401
  bump_world2:update(player_lvl2, 642, 401)
  Gamestate.switch(level3)
  level3:enter()
end

return game
