local game = {}
love.graphics.setDefaultFilter('nearest', 'nearest')

spawn_x_lvl3, spawn_y_lvl3 = 32, 18

screen3 = {alpha = 0, wait = 0,subtle_wait = 0}

--Laser world
laser_world3 = World.new()

--Lasers for level 3
local Lasers3 = require "lasers3"
local lasers3 = Lasers3.new()

lasers3Timer = Timer.new()


bump_world3 = bump.newWorld(16)
local map = sti("map3/map3.lua", {"bump"})
map:bump_init(bump_world3)

player_lvl3 = Player.new(spawn_x_lvl3, spawn_y_lvl3, bump_world3)
bump_world3:add(player_lvl3, player_lvl3.x, player_lvl3.y, player_lvl3.w, player_lvl3.h)
laser_world3:add(player_lvl3)

local Doors3 = require "doors3"
local doors3 = Doors3.new()

artifact = Artifact.new()

function game:enter()
  screen3.alpha = 1.3
  const.level_complete = false
  const.level1_complete = false
  const.level2_complete = false

--Camera settings
  camera3 = Camera(player_lvl3.x, player_lvl3.y)
  camera3.scale = 4
  camera3:setDeadzone(const.ww/2, const.wh/4, 40,220)
  camera3:setFollowLerp(0.02)
  camera3:setBounds(-268,-174, 1270,990)

end

function game:update(dt)
  camera3:update(dt)
  if const.get_out then
    camera3:shake(5, 0.1, 20)
    camera3:fade(0.5, {0.25, 0, 0, math.random(0.1, 0.4)})
  end
  camera3:follow(player_lvl3.x, player_lvl3.y)
  if not run.timeout then
    for i, item in ipairs(laser_world3.items) do
      if item.update then
        item:update(dt)
      end
    end
  end
  lasers3:update(dt)
  doors3:update(dt)
  if screen3.alpha > 0 then
    screen3.alpha = screen3.alpha - 0.025
  end
  level3Done()
  level3Transition()
  artifactAcquired()
end


function game:keypressed(key)
  if key == 'p' and gameover.is_enabled == false and run.timeout == false then
      Gamestate.push(pause)
    end
  if key == 'return' and gameover.is_enabled == true then
    love.event.quit()
  end
  if key == 'r' and const.get_out == true then
    resetLevel3()
  end
end

function game:draw()
  love.graphics.setColor(1,1,1,1)
  camera3:attach()
  love.graphics.draw(const.bg)


  for i, item in ipairs(laser_world3.items) do
    if not const.get_out then
      item:draw()
    elseif item.isPlayer then
      item:draw()
    end
  end

  doors3:draw()
  map:draw()

  camera3:detach()
  camera3:draw()
  love.graphics.setColor(0,0,0,screen3.alpha)
  fade = love.graphics.rectangle('fill', 0, 0, const.ww+50, const.wh+100)
  run:draw()
end

function level3Done ()
  if player_lvl3.x < 0 then
    player_lvl3.isDisabled = true
    const.level_complete = true
    const.level3_complete = true
  end
end


function level3Transition()
  if const.level_complete == true then
    breath:play()
    screen3.subtle_wait = screen3.subtle_wait + 0.025
    if screen3.alpha < 1 and screen3.subtle_wait > 0.99 then
      screen3.alpha = screen3.alpha + 0.05
    end

    if screen3.alpha > 0.99 then
      if screen3.wait < 1 then
      screen3.wait = screen3.wait + 0.01
      end
    end
    if screen3.wait > 0.99 then
      const.level2_complete = false
      bump_world3:update(player_lvl3, 611, 129)
      Gamestate.switch(level2)
    end
  end
end

function resetLevel3()
  player_lvl3.x = 611
  player_lvl3.y = 129
  bump_world3:update(player_lvl3, 611, 129)
  run.m = 3
  run.paused = false
  run.timeout = false
  Gamestate.switch(level3)
  level3:enter()
end

return game
