local menu = {}


local bg1 = love.graphics.newImage('img/bg2.png')
local bg2 = love.graphics.newImage('img/bg2.png')

local start_img_cold = love.graphics.newImage("img/StartButton.png")
local start_img_hot = love.graphics.newImage("img/StartButton2.png")

local quit_img_cold = love.graphics.newImage("img/QuitButton.png")
local quit_img_hot = love.graphics.newImage("img/QuitButton2.png")
-- local start_img_cold = love.graphics.newImage("img/cold_butt.png")
-- local start_img_hot = love.graphics.newImage("img/hot_butt.png")
--
-- local quit_img_cold = love.graphics.newImage("img/cold_butt.png")
-- local quit_img_hot = love.graphics.newImage("img/hot_butt.png")

local ww = love.graphics.getWidth()
local wh = love.graphics.getHeight()

local bg_x1, bg_y1 = 0,0
local bg_x2, bg_y2 = 0, -wh

local function newButton (name, img, fn)
  return {
    name = name,
    img = img,
    fn = fn,
    now = false,
    last = false
  }
end

buttons = {}

function menu:enter()
  table.insert(buttons, newButton("Start", start_img_cold, function()
    print("Starting game...")
    Gamestate.switch(instructions)
  end))
  table.insert(buttons, newButton("Quit", quit_img_cold, function()
    print("Quiting game...")
    love.event.quit()
  end))
end

function menu:update(dt)
  bg_y1 = bg_y1 + 1
  bg_y2 = bg_y2 + 1
  if bg_y1 > wh then
    bg_y1 = 0
  end
  if bg_y2 > 0 then
    bg_y2 = -wh
  end
end

function menu:keypressed(key)
  if key == "q" then
    love.event.quit()
  end
end

function menu:draw()
  love.graphics.setDefaultFilter('nearest', 'nearest')
  love.graphics.setFont(font)
  local button_width = 312
  local button_height = 78
  local margin = 15
  local cursor_y = 0
  local total_height = (button_height + margin) * #buttons


  love.graphics.setColor(1,1,1,1)
  love.graphics.draw(bg1, bg_x1, bg_y1)
  love.graphics.draw(bg2, bg_x2, bg_y2)

  love.graphics.setColor(0,0,0,0.65)
  love.graphics.rectangle("fill", 0, 0, 720, 480)
  love.graphics.setColor(1,1,1,1)

  for i, button in ipairs(buttons) do
    button.last = button.now
    local bx = (ww * 0.5) - (button_width * 0.5)
    local by = (wh * 0.5) - (total_height * 0.5) + cursor_y

    local mx, my = love.mouse.getPosition()
    local hot = mx > bx and mx < bx + button_width and
                my > by and my < by + button_height

    if hot then
      if button.name == "Start" then
        button.img = start_img_hot
      elseif button.name == "Quit" then
        button.img = quit_img_hot
      end
    end

    if not hot then
      if button.name == "Start" then
        button.img = start_img_cold
      elseif button.name == "Quit" then
        button.img = quit_img_cold
      end
    end

    button.now = love.mouse.isDown(1)
    if button.now and not button.last and hot then
      button.fn()
    end

    love.graphics.draw(button.img, bx, by)

    -- love.graphics.setColor(0,0,0,1)
    -- local textW = font:getWidth(button.name)
    -- local textH = font:getHeight(button.name)
    -- love.graphics.print(button.name, (ww * 0.5) - textW * 0.5, by + textH * 0.5)
    -- love.graphics.setColor(1,1,1)


    cursor_y = cursor_y + (button_height + margin)
  end

end

return menu
