local mt = {}
mt.__index = mt

local img = love.graphics.newImage('img/platform.png')

local vy = 0
local speed = -0.01

function mt:update(dt)
  vy = vy + speed *dt

  local goalX, goalY = self.x, self.y + vy
  local actualX, actualY, cols, len = bump_world:move(self, goalX, goalY, touch)
  self.y = actualY

end

function mt:draw ()
  love.graphics.draw(img, self.x, self.y)
end

return {
  new = function (x, y)
    return setmetatable({
      x = x,
      y = y,
      w = 32,
      h = 10,
    }, mt)
  end
}
